#include "NeuMeshLoader.h"
#include "Exceptions.h"

#include <fstream>
#include <iostream>

void NeuMeshLoader::LoadMesh(const std::string& filename) 
{
    std::ifstream fin(filename);
    if (!fin) {
        throw NoFileFoundException(filename);
    } else std::cout << "File \"" << filename << "\" was opened successfully." << std::endl;

    int amount;

    fin >> amount;
    nodes.reserve(amount);
    for (int i = 1; i <= amount; ++i) {
		Node temp_node;
		temp_node.id = i;
		fin >> temp_node.x >> temp_node.y >> temp_node.z;
		temp_node.vertex = true;
		nodes.push_back(temp_node);
    }

    fin >> amount;
    
	int dimension = 4; 

    elements.reserve(amount);

    for (int i = 1; i <= amount; ++i) 
    {
		FiniteElement temp_element;
        temp_element.element_id = i;
        fin >> temp_element.material_id;
        temp_element.nodes_id.reserve(dimension);
        int temp_id;
        for (int j = 0; j < dimension; ++j) 
        {
            fin >> temp_id;
            temp_element.nodes_id.push_back(temp_id);
        }
		elements.push_back(temp_element);
    }

    fin >> amount;

    dimension = 3;

	boundary.reserve(amount);

    for (int i = 1; i <= amount; ++i) 
    {
		BoundaryFiniteElement temp_surface;
        temp_surface.element_id = i;
        fin >> temp_surface.border_id;
        temp_surface.nodes_id.reserve(dimension);
        int temp_id;
        for (int j = 0; j < dimension; ++j) {
            fin >> temp_id;
            temp_surface.nodes_id.push_back(temp_id);
        }
		boundary.push_back(temp_surface);
    }

    fin.close();
    std::cout << "All data has been loaded successfully!" << std::endl << " File will be closed!" << std::endl;
}
